#ifndef ETHERNETSERVER_H
#define ETHERNETSERVER_H

#include "Server.h"
#include "EthernetClient.h"

class EthernetServer : public Server
{
  public:
    EthernetServer(uint16_t port);

    virtual EthernetClient available();
    void setMaxSocks(int socks);
    inline int maxSocks() {
      return max_socks;
    }
    inline uint16_t port() {
      return _port;
    }

    virtual void begin();
    virtual size_t write(uint8_t);
    virtual size_t write(const uint8_t *buf, size_t size);
    using Print::write;

  protected:
    virtual void accept();
    uint16_t _port;

    int max_socks;
    int last_sock;
    int socks_num;
};

#endif // ETHERNETSERVER_H
